<template>

<!-- NO LONGER IN USE AFTER COMPONENTIZATION -->

      <div>
        <q-card>
          <q-card-title>
            <q-search v-model="searchterm" placeholder="Search" float-label="Enter search terms" v-on:keyup.enter="addsearchterm(searchterm)"/>
            <div class="row justify-center">
              <q-chip 
              closable
              v-for="(term, index) in searchterms" 
              :key="index"
              @close="removeterm(index)"
              @click="toggleterm(index)"
              :class="[term.active ? 'bg-blue text-white' : 'bg-red text-white']">{{ term.name }}</q-chip>
            </div>
          </q-card-title>
          <!-- <q-card-separator/> -->
          <q-card-main>
            <q-list highlight separator no-border>
              <q-list-header>Results <span class="on-right">{{ totalresults }}</span></q-list-header>
              <q-item v-for="r in results" :key="r.id" @click="select(r)" class="text-dark">
                <q-item-side>
                  <q-item-tile>
                    <q-checkbox
                    v-model="r.selected"
                    color="info"/>
                  </q-item-tile>
                  <!-- <q-item-tile icon="face" color="green" /> -->
                </q-item-side>
                <q-item-main>
                  <q-item-tile label>{{ r.stacks[0].stack[0] }}</q-item-tile>
                  <q-item-tile sublabel lines="1">
     <!--                <p
                    v-for="sublabel in sublabels[index]">
                      {{ sublabel.name }}
                    </p> -->
                    <!-- {{ csublabels[index]}} -->
                    {{ r.topstr }}
                  </q-item-tile>
                </q-item-main>
                <q-item-side right>
                  <q-item-tile class="text-positive">
                    {{ Math.round(r.experience/12) }} Yrs.
                  </q-item-tile>
                </q-item-side>
              </q-item>
            </q-list>
            <div class="row justify-center">
              <q-pagination
                input
                v-model="currentpage"
                :min="1"
                :max="numpages"
                @change="searchresumes()"
              />
            </div>
          </q-card-main>
        </q-card>

        <q-modal v-model.lazy="showmodal" maximized>
          <q-modal-layout>
            <q-toolbar slot="header">
              <q-btn
                flat
                round
                dense
                @click="unselect()"
                icon="reply"
                wait-for-ripple
              />
              <q-toolbar-title>
                {{ selected.name }}
              </q-toolbar-title>
            </q-toolbar>

<!--             <q-toolbar slot="footer">
              <q-toolbar-title>
                Footer
              </q-toolbar-title>
            </q-toolbar> -->

            <div class="layout-padding q-pa-sm">
              <q-card>
                <q-card-title class="bg-primary text-white">Skills</q-card-title>
                <q-card-main>
                  <q-list separator no-border>
                    <q-item
                    v-for="skill in selected.skills"
                    :key="skill.name"
                    class="text-faded">
                      <q-item-main>{{ skill.name }}</q-item-main>
                      <q-item-side right>{{ Math.round(skill.experience/12) }} Yrs.</q-item-side>
                    </q-item>
                  </q-list>
                </q-card-main>
              </q-card>

              <q-card>
                <q-card-title class="bg-primary text-white">Sections</q-card-title>
                <q-card-main>
                  <q-collapsible
                  v-for="section in selected.stacks"
                  :key="section[0]"
                  :label="[section.dates.length === 2 ? section.dates[0] + ' to ' + section.dates[1] + '\t(' + section.duration + ' mo.)' : 'No Info'][0]"
                  class="text-secondary">
                    <q-chip
                    v-for="skill in section.skills"
                    :key="skill.id"
                    class="q-ma-lg bg-info text-white">
                      {{ skill.name }}
                    </q-chip>
                    <p
                    v-for="line in section.stack"
                    :bind="line"
                    class="text-faded">
                      {{ line }}
                    </p>
                  </q-collapsible>
                </q-card-main>
              </q-card>
            </div>
          </q-modal-layout>
        </q-modal>

      </div>

</template>

<script>
import taleanconnector from './taleanconnector'
import helper from './helper'
import {
  QBtn,
  QIcon,
  QList,
  QListHeader,
  QItem,
  QItemSide,
  QItemMain,
  QItemSeparator,
  QItemTile,
  QCard,
  QCardTitle,
  QCardSeparator,
  QCardMain,
  QSearch,
  // QChipsInput
  QChip,
  QAutocomplete,
  Loading,
  QSpinnerGears,
  QModal,
  QModalLayout,
  QToolbar,
  QToolbarTitle,
  QCollapsible,
  QPagination,
  QCheckbox
} from 'quasar'

export default {
  name: 'index',
  components: {
    QBtn,
    QIcon,
    QList,
    QListHeader,
    QItem,
    QItemSide,
    QItemMain,
    QItemSeparator,
    QItemTile,
    QCard,
    QCardTitle,
    QCardSeparator,
    QCardMain,
    QSearch,
    // QChipsInput
    QChip,
    QAutocomplete,
    Loading,
    QSpinnerGears,
    QModal,
    QModalLayout,
    QToolbar,
    QToolbarTitle,
    QCollapsible,
    QPagination,
    QCheckbox
  },
  data () {
    return {
      totalresults: 0,
      results: [],
      searchterm: '',
      searchterms: [],
      // from: 0,
      size: 15,
      showmodal: false,
      selected: {
        'skills': []
      },
      currentpage: 1
    }
  },
  created: function () {
    if (!this.$session.get('loggedin')) {
      this.$router.push('/login')
    }
    this.searchresumes()
  },
  computed: {
    csublabels () {
      return this.sublabels.map((val) => {
        let str = ''
        for (let i = 0; i < val.length; i++) {
          str += val[i].name + ' | '
        }
        str = str.substring(0, str.length - 3)
        return str
      })
    },
    sublabels () {
      return this.results.map((val) => {
        if (val.skills.length < 3) {
          return val.skills.splice(0, val.skills.length)
        }
        return val.skills.splice(0, 3)
      })
    },
    selectedresumes () {
      return this.results.filter((val) => {
        return val.selected
      })
    },
    // selectedsortedskills: function () {
    //   return this.selected.skills.sort(function (a, b) {
    //     if (a.experience > b.experience) {
    //       return -1
    //     }
    //     if (a.experience < b.experience) {
    //       return 1
    //     }
    //     return 0
    //   })
    // },
    numpages () {
      return Math.ceil(this.totalresults / this.size)
    },
    from () {
      return (this.currentpage * this.size) - this.size
    }
  },
  methods: {
    searchresumes: function () {
      Loading.show({
        'delay': 10 // show in 10ms
      })
      let filteredterms = this.searchterms.filter((val) => {
        return val.active
      })
      let tsearchterms = filteredterms.map((val) => {
        return val.name
      })
      // console.log(this.from, this.size)
      taleanconnector.searchresumes(tsearchterms, this.from, this.size)
        .then((response) => {
          // console.log(response)
          this.results = response.data
          this.totalresults = response.total
          // console.log(this.results)
          Loading.hide()
        })
        .catch((err) => {
          console.log(err)
          Loading.hide()
        })
    },
    addsearchterm: function () {
      let myterms = this.searchterms.map((val) => {
        return val.name
      })
      if (this.searchterm === '' || helper.containsCaseInsensitive(myterms, this.searchterm)) {
        this.searchterm = ''
        return
      }
      this.searchterms.push({
        'name': this.searchterm,
        'active': true
      })
      this.searchterm = ''
      this.searchresumes()
    },
    search: function (searchterm, done) {
      // console.log(searchterm)
      taleanconnector.searchskills(searchterm)
        .then((response) => {
          // console.log(response)
          let fdata = response.map((val) => {
            return val.name
          })
          // console.log(fdata)
          done(fdata)
        })
        .catch((err) => {
          console.log(err)
        })
    },
    toggleterm: function (index) {
      this.searchterms[index].active = !this.searchterms[index].active
      this.searchresumes()
    },
    removeterm: function (index) {
      this.searchterms.splice(index, 1)
      this.searchresumes()
    },
    select: function (item) {
      this.selected = item
      this.showmodal = true
      console.log(this.selected)
    },
    unselect: function () {
      this.selected = {
        'skills': []
      }
      this.showmodal = false
    }
  },
  mounted () {
  },
  beforeDestroy () {
  }
}
</script>

<style lang="stylus">
</style>
